;*******************************************************************************
;                                                                              *
;        .                                     *
;    focus - Kenwood                                                        *
;                                                                              *
;*******************************************************************************

		list p=12f675
		#include <p12f675.inc>
		errorlevel -302
		__CONFIG _CP_OFF&_CPD_OFF&_BODEN_ON&_MCLRE_ON&_WDT_OFF&_PWRTE_ON&_INTRC_OSC_NOCLKOUT 

;*******************************************************************************
;    .

IRPort		EQU	1		;  -.
CtlPort		EQU	2		;   .

;   -.

IrAdrH		EQU	0x46		;    .
IrAdrL		EQU	0xB9		;    .

;   -.

IRCmd0		EQU	0x15		;    Btn0 (Vol-).
IRCmd1		EQU	0x14		;    Btn1 (Vol+).
IRCmd2		EQU	0x12		;    Btn2 (Seek+).
IRCmd3		EQU	0x13		;    Btn3 (Seek-).
IRCmd4		EQU	0x0A		;    Btn4 (Mode).

;       .

Btn0		EQU	.23		;   Vol-.
Btn1		EQU	.46		;   Vol+.
Btn2		EQU	.75		;   Seek+.
Btn3		EQU	.111		;   Seek-.
Btn4		EQU	.190		;   Mode.

;  .

CLen		EQU	0x20		;   
					; (   ).
CLenV		EQU	0x21		;     .
IrCmd		EQU	0x24		;   .
SendB		EQU	0x25		; ,   SendByte.
Btn		EQU	0x26		;   
					; (0-4  5 -  ). 
BtnPrev		EQU	0x27		;    .
BtnTmp		EQU	0x28		;    .
ADCRes		EQU	0x29		;  .
Mode		EQU	0x2A		;  .
P1msV		EQU	0x30		;     .
PNmsV		EQU	0x31		;     .
CfrmLoopV	EQU	0x32		;   CfrmLoop.

;*******************************************************************************

		ORG	0x000		;  .
		goto	Main		;    .

;*******************************************************************************
;  N  (   N  W).

PNms		movwf	PNmsV		;   W  .

PNmsLoop	nop

;     1 .

		movlw	.199
		movwf	P1msV
P1msLoop	goto	$+1
		decfsz	P1msV,F
		goto	P1msLoop

;  N    1 .

		decfsz	PNmsV,F
		goto	PNmsLoop
		return

;*******************************************************************************
;  .
;   38 kHz  26    - 1 MHz (
;    4 MHz)  26     38461 Hz.
;   25% -  7    19 .

Carrier		movf	CLen,W		;   
		movwf	CLenV		;     .

CarrLoop	bsf	GPIO,IRPort	;  -.
		goto	$+1		;  6 .
		goto	$+1
		goto	$+1

		bcf	GPIO,IRPort	;  -.
		goto	$+1		;  15 
		goto	$+1		;  3   (),
		goto	$+1		;  18.
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1
		nop

		decfsz	CLenV,F		;  ,   
		goto	CarrLoop	;   .

		return

;*******************************************************************************
;   (   ).

Pause		movf	CLen,W
		movwf	CLenV

PauseLoop	goto	$+1		;   23 
		goto	$+1		;  3  ,
		goto	$+1		;  26.
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1
		nop

		decfsz	CLenV,F
		goto	PauseLoop

		return

;*******************************************************************************
;   -.
;  Nec:  9 ms (346 )   4.5 ms (173 ).

IRStart		bsf	GPIO,CtlPort	;   REMOTE.

		movlw	.90		;  
		movwf	CLen		;   
		call	Carrier		;   .

		movlw	.255		;  
		movwf	CLen		;   
		call	Carrier		;   .

	 	bcf	GPIO,CtlPort	;   REMOTE.

		movlw	.173		;  
		movwf	CLen		;   
		call	Pause		;   .

		return

;*******************************************************************************
;   -
;  Nec:  9 ms (346 ),  2.25 ms (84 )  
;           560 us (21 ).

SendRepeat	bsf	GPIO,CtlPort	;   REMOTE.

		movlw	.90		;  
		movwf	CLen		;   
		call	Carrier		;   .

		movlw	.255		;  
		movwf	CLen		;   
		call	Carrier		;   .

		bcf	GPIO,CtlPort	;   REMOTE.

		movlw	.84		;  
		movwf	CLen		;   
		call	Pause		;   .

		bsf	GPIO,CtlPort	;   REMOTE.

		movlw	.21		;  
		movwf	CLen		;   
		call	Carrier		;   .

		bcf	GPIO,CtlPort	;   REMOTE.

		return

;*******************************************************************************
;  "1" -
;  Nec:  560 us (21 )   1.68 ms (63 )

IR1		bsf	GPIO,CtlPort	;   REMOTE.

		movlw	.21		;  
		movwf	CLen		;   
		call	Carrier		;   .

		bcf	GPIO,CtlPort	;   REMOTE

		movlw	.63		;  
		movwf	CLen		;   
		call	Pause		;   .

		return

;*******************************************************************************
;  "0" -
;  Nec:  560 us (21 )   560 us (21 )

IR0		bsf	GPIO,CtlPort	;   REMOTE.

		movlw	.21		;  
		movwf	CLen		;   
		call	Carrier		;   .

		bcf	GPIO,CtlPort	;   REMOTE  

		movlw	.21		;  
		movwf	CLen		;   
		call	Pause		;   .

		return

;*******************************************************************************
;  .

SendByte	btfss	SendB,0		;   "1",
		call	IR0		;   "0".
		btfsc	SendB,0		;   "0",
		call	IR1		;   "1".
		btfss	SendB,1
		call	IR0
		btfsc	SendB,1
		call	IR1
		btfss	SendB,2
		call	IR0
		btfsc	SendB,2
		call	IR1
		btfss	SendB,3
		call	IR0
		btfsc	SendB,3
		call	IR1
		btfss	SendB,4
		call	IR0
		btfsc	SendB,4
		call	IR1
		btfss	SendB,5
		call	IR0
		btfsc	SendB,5
		call	IR1
		btfss	SendB,6
		call	IR0
		btfsc	SendB,6
		call	IR1
		btfss	SendB,7
		call	IR0
		btfsc	SendB,7
		call	IR1

		return

;*******************************************************************************
;    Nec.
;  , IrAdrL, IrAdrH, IrCmd,  IrCmd, -.



SendCmd		call	IRStart		;  .

		movlw	IrAdrL		;     ,
		movwf	SendB		;     
		call	SendByte	;  .

		movlw	IrAdrH		;     
		movwf	SendB		;  ..
		call	SendByte

		movf	IrCmd,W		;     ..
		movwf	SendB
		call	SendByte

		comf	IrCmd,W		;     ..
		movwf	SendB
		call	SendByte

		call	IR0		; -.

		
		return

;*******************************************************************************

Zad		movlw	0x36		; 
		call	PNms		;  55 .
		return

;*******************************************************************************
;   .

BtnCheck

; .

		bsf	ADCON0,GO	;  .
ADCLoop		btfsc	ADCON0,GO	; ,  
		goto	ADCLoop		;   .
		movf	ADRESH,W	;    
		movwf	ADCRes		;    
					;  (""  8bit).

;      .

		clrf	Btn		;    .

		movf	ADCRes,W	;   .
		bsf	STATUS,C	;   .
		sublw	Btn0		;     .
		btfss	STATUS,C	;     - ,
		incf	Btn,F		;    .

		movf	ADCRes,W
		bsf	STATUS,C
		sublw	Btn1
		btfss	STATUS,C
		incf	Btn,F

		movf	ADCRes,W
		bsf	STATUS,C
		sublw	Btn2
		btfss	STATUS,C
		incf	Btn,F

		movf	ADCRes,W
		bsf	STATUS,C
		sublw	Btn3
		btfss	STATUS,C
		incf	Btn,F

		movf	ADCRes,W
		bsf	STATUS,C
		sublw	Btn4
		btfss	STATUS,C
		incf	Btn,F

		return

;*******************************************************************************
;     -.

Btn2IR		addwf	PCL,F		;   .
		retlw	IRCmd0		;    Btn0.
		retlw	IRCmd1		;    Btn1.
		retlw	IRCmd2		;    Btn2.
		retlw	IRCmd3		;    Btn3.
		retlw	IRCmd4		;    Btn4.
		
;*******************************************************************************
;  .

Main

;    RC-.
			
		call	0x3FF		;    .
		bsf	STATUS,RP0	;  1. 
		movwf	OSCCAL		;   . 
		bcf	STATUS,RP0	;  0.

;   .

		clrf	GPIO		;   .
		bsf	STATUS,RP0	;  1.
		movlw	b'010000'	;    
		movwf	TRISIO		;   .
		bcf	STATUS,RP0	;  0.

;   .

		bcf	ADCON0,ADFM	;  .
		bcf	ADCON0,VCFG	;   Vdd.
		bsf	ADCON0,CHS1	; 
		bsf	ADCON0,CHS0	;  AN3.
		bcf	ADCON0,GO	;   .
		bsf	ADCON0,ADON	;   .

		bsf	STATUS,RP0	;  1.
		bsf	ANSEL,ADCS2	;  
		bcf	ANSEL,ADCS1	;  
		bsf	ANSEL,ADCS0	; Fosc/16.
		bsf	ANSEL,ANS3	;   AN0  ,
		bcf	ANSEL,ANS2	; 
		bcf	ANSEL,ANS1	;  
		bcf	ANSEL,ANS0	; .
		bcf	STATUS,RP0	;  0.

		movlw	0x01		;   
		call	PNms		;   1 .

;  .

MainLoop	clrf	Mode		;   .	
		call	BtnCheck	;  .

; ,    .

		movf	Btn,W		;    ,
		sublw	0x08		;      8.
		btfsc	STATUS,Z	;    8,   ,
		goto	MainLoop	;    .

;   .

		movf	Btn,W		;   
		movwf	BtnTmp		;     .
		movlw	0x08		;   
		movwf	BtnPrev		; BtnPrev=8.

;    (5 ).

CfrmStart

		movlw	0x05		;  5 
		movwf	CfrmLoopV	;    .

CfrmLoop	movlw	0x09		;  9 
		call	PNms		;  .

;  .

		call	BtnCheck	;  .

; ,  -    (Btn=BtnTemp?).

		movf	Btn,W		;    ,
		subwf	BtnTmp,W	;     .
		btfss	STATUS,Z	;   ,  ,
		goto	MainLoop	;    .

;    

		decfsz	CfrmLoopV,F	;   1   
		goto	CfrmLoop	;    0,  .

;  .
; ,      (Btn=BtnPrev?).

		movf	Btn,W		;    ,
		subwf	BtnPrev,W	;      .
		btfss	STATUS,Z	;  Btn=BtnTmp -   ,
		goto	SendNewCmd	;     .

;   

		movlw	0x04		;    Mute, 
		subwf	Btn,W		;   ,
		btfsc	STATUS,Z	;   
		goto	CfrmStart	;     .

		movlw	0x05		;    Mode, 
		subwf	Btn,W		;   ,
		btfsc	STATUS,Z	;   
		goto	CfrmStart	;     .

		btfsc	Mode,0	 	;     , 
		call	Zad		; 

		call	SendRepeat	;    
		bsf	Mode,0		;   .
		goto	CfrmStart	;     .

;   

SendNewCmd	movf	Btn,W		;    ,
		movwf	BtnPrev		;    ,
		call	Btn2IR		;      ,
		movwf	IrCmd		;    
		call	SendCmd		;  .

		goto	CfrmStart	;     .

		END			;  .